angular.module('beamng.apps')
.directive('cbzFuel', ['$log', function ($log) {
	
	let style = document.createElement('style');
    style.type = 'text/css';
    style.innerHTML = `
      @font-face {
        font-family: 'Hemi';
        src: url('/ui/modules/apps/cbzhemi.ttf') format('truetype');
      }

      .cbzfuelt {
        font-family: 'Hemi';
        color: white;
      }


      .cbzfuelu {
        font-family: 'Hemi';
        color: orange;
      }
	  `;

    return {
      template:
	  `
      <div style="width:100%; height:100%;" layout="column" align="center" class="bngApp" id="cbzFuel">
		<p class="cbzfuelt" style="margin-top: -5%; margin-bottom: -10%">{{speed}}</p>
		<p class="cbzfuelu" style="margin-top:  4%; margin-bottom: -10%;">{{unit}}</p>
	  </div>`,
      replace: true,
      restrict: 'EA',
      link: function (scope, element, attrs) {
        StreamsManager.add(['electrics', 'engineInfo']);
		
		document.getElementsByTagName('head')[0].appendChild(style);
	
	window.setTimeout( function() {
		var doc = document.getElementById('cbzFuel');
		var doc1 = document.getElementById('cbzFuel').getElementsByClassName('cbzfuelt');
		var doc2 = document.getElementById('cbzFuel').getElementsByClassName('cbzfuelu');
		var h = doc.clientHeight;
		doc1[0].style.fontSize=h*0.65+'px';
		doc2[0].style.fontSize=h*0.30+'px';
	}, 10);
		
		
		
        scope.$on('streamsUpdate', function (event, streams) {
			if (streams.engineInfo != null && streams.electrics != null) {
				        
				var fuel = streams.electrics.fuel;
				scope.unit="Fuel left";
					scope.fuel = scope.fuel*10;
					scope.fuel = Math.floor(fuel*1000);
					scope.fuel = scope.fuel/10;
					scope.speed = (scope.fuel + "%");
				scope.$digest();

		var colchange = document.getElementById('cbzFuel').getElementsByClassName('cbzfuelt');
	                if(scope.fuel < 0.01) { //we are low, red
	                    colchange[0].style.color = "tomato"
 	               } else if(scope.fuel < 20) { //we are near low, orange
 	                    colchange[0].style.color = "gold"
  	               } else { //normal amount, white
  	                    colchange[0].style.color = "white"
   	               }

			};
        });

        scope.$on('$destroy', function () {
          StreamsManager.remove(['electrics', 'engineInfo']);
        });
      }
    };
  }]);
