angular.module('beamng.apps')
.directive('cbzSpeedoKM', ['$log', function ($log) {
	
	let style = document.createElement('style');
    style.type = 'text/css';
    style.innerHTML = `
      @font-face {
        font-family: 'Hemi';
        src: url('/ui/modules/apps/cbzhemi.ttf') format('truetype');
      }

      .speedo-display {
        font-family: 'Hemi';
        color: white;
      }
      .speedo-display-aux {
        font-family: 'Hemi';
        color: lightgrey;
      }
	  `;

    return {
      template:
	  `
      <div style="width:100%; height:100%;" layout="column" align="center" class="bngApp" id="cbzSpeedoKM">
		<p class="speedo-display" style="margin-top: -6.5%; margin-bottom: -10%">{{speedk}}</p>
		<p class="speedo-display" style="margin-top: -1.0%; margin-bottom: -10%">{{units}}</p>
		<p class="speedo-display-aux" style="margin-top:  5.5%; margin-bottom: -10%">{{speedm}}</p>
	  </div>`,
      replace: true,
      restrict: 'EA',
      link: function (scope, element, attrs) {
        StreamsManager.add(['electrics', 'engineInfo']);
		
		document.getElementsByTagName('head')[0].appendChild(style);
	
	window.setTimeout( function() {
		var doc = document.getElementById('cbzSpeedoKM');
		var doc1 = document.getElementById('cbzSpeedoKM').getElementsByClassName('speedo-display');
		var doc2 = document.getElementById('cbzSpeedoKM').getElementsByClassName('speedo-display-aux');
		var h = doc.clientHeight;
		doc1[0].style.fontSize=h*0.65+'px';
		doc1[1].style.fontSize=h*0.12+'px';
		doc2[0].style.fontSize=h*0.35+'px';
	}, 10);
		
		
		
        scope.$on('streamsUpdate', function (event, streams) {
			if (streams.engineInfo != null && streams.electrics != null) {
				        
				var wspeed = streams.electrics.wheelspeed;
				scope.units="--- kmh / mph ---";
					scope.speedk = Math.floor(wspeed*3.6);
					scope.speedm = Math.floor(wspeed*3.6/1.6);
				scope.$digest();
			};
        });

        scope.$on('$destroy', function () {
          StreamsManager.remove(['electrics', 'engineInfo']);
        });
      }
    };
  }]);
