angular.module('beamng.apps')
.directive('cbzSpeedoM', ['$log', function ($log) {
	
	let style = document.createElement('style');
    style.type = 'text/css';
    style.innerHTML = `
      @font-face {
        font-family: 'Hemi';
        src: url('/ui/modules/apps/cbzhemi.ttf') format('truetype');
      }

      .speedo-display {
        font-family: 'Hemi';
        color: white;
      }
	  `;

    return {
      template:
	  `
      <div style="width:100%; height:100%;" layout="column" align="center" class="bngApp" id="cbzSpeedoM">
		<p class="speedo-display" style="margin-top: -6%; margin-bottom: -10%">{{speed}}</p>
		<p class="speedo-display" style="margin-top: 2%; margin-bottom: -10%;">{{unit}}</p>
	  </div>`,
      replace: true,
      restrict: 'EA',
      link: function (scope, element, attrs) {
        StreamsManager.add(['electrics', 'engineInfo']);
		
		document.getElementsByTagName('head')[0].appendChild(style);
	
	window.setTimeout( function() {
		var doc = document.getElementById('cbzSpeedoM');
		var doc1 = document.getElementById('cbzSpeedoM').getElementsByClassName('speedo-display');
		var h = doc.clientHeight;
		doc1[0].style.fontSize=h*0.8+'px';
		doc1[1].style.fontSize=h*0.2+'px';
	}, 10);
		
		
		
        scope.$on('streamsUpdate', function (event, streams) {
			if (streams.engineInfo != null && streams.electrics != null) {
				        
				var wspeed = streams.electrics.wheelspeed;
				scope.unit="mph";
					scope.speed = Math.floor(wspeed*3.6/1.6);
				scope.$digest();
			};
        });

        scope.$on('$destroy', function () {
          StreamsManager.remove(['electrics', 'engineInfo']);
        });
      }
    };
  }]);
