angular.module('beamng.apps')
.directive('cbzStats', ['$log', function ($log) {
	
	let style = document.createElement('style');
    style.type = 'text/css';
    style.innerHTML = `
      @font-face {
        font-family: 'Hemi';
        src: url('/ui/modules/apps/cbzhemi.ttf') format('truetype');
      }

      .cbzStatsvarP {
        font-family: 'Hemi';
        color: tomato;
      }

      .cbzStatsR {
        font-family: 'Hemi';
        color: white;
      }

      .cbzStatsW {
        font-family: 'Hemi';
        color: lightgreen;
      }
	  `;

    return {
      template:
	  `
      <div style="width:100%; height:100%;" layout="column" align="center" class="bngApp" id="cbzStats">
		<p class="cbzStatsvarP" style="margin-top: 0.8%; margin-bottom: 0%">{{curHP}} / {{powerHP}} hp</p>
		<p class="cbzStatsR" style="margin-top: 0%; margin-bottom: 0%">{{ratio}} hp/kg</p>
		<p class="cbzStatsW" style="margin-top: 0%; margin-bottom: 0%">{{weight}} kg</p>
	  </div>`,
      replace: true,
      restrict: 'EA',
      link: function (scope, element, attrs) {
        StreamsManager.add(['engineInfo']);
		
		document.getElementsByTagName('head')[0].appendChild(style);
	
	window.setTimeout( function() {
		var doc = document.getElementById('cbzStats');
		var doc1 = document.getElementById('cbzStats').getElementsByClassName('cbzStatsvarP');
		var doc2 = document.getElementById('cbzStats').getElementsByClassName('cbzStatsR');
		var doc3 = document.getElementById('cbzStats').getElementsByClassName('cbzStatsW');
		var h = doc.clientHeight;
		doc1[0].style.fontSize=h*0.22+'px';
		doc2[0].style.fontSize=h*0.24+'px';
		doc3[0].style.fontSize=h*0.28+'px';
	}, 10);



	let powerNew = 0;
	let powerOld = 0;



	const LuaPower = `(function()return powertrain.getDevicesByCategory("engine")[1].maxPower end)()`;
	const LuaWeight = `(function()return obj:calcBeamStats().total_weight end)()`;

	bngApi.activeObjectLua(LuaPower, function(power){
	scope.power = Math.ceil(power)
	scope.powerHP = Math.ceil(power * 0.986)
	powerNew = scope.power
	})
	
	bngApi.activeObjectLua(LuaWeight, function(weight){
	scope.weight = Math.ceil(weight)
	weightNew = scope.weight
	scope.ratio = powerNew / weightNew
	scope.ratio = scope.ratio.toFixed(3);
	})
		

	scope.$on('VehicleFocusChanged', function(){
		
		
		setTimeout(()=>bngApi.activeObjectLua(LuaPower, function(power){
	    scope.power = Math.ceil(power)
		scope.powerHP = Math.ceil(power * 0.986)
		powerNew = scope.power
		scope.powerDif = (powerOld - powerNew) * (-1)
		
		}), 50)
		
		setTimeout(()=>bngApi.activeObjectLua(LuaWeight, function(weight){
	    scope.weight = Math.ceil(weight)
		weightNew = scope.weight
		scope.weightDif = weightNew - weightOld
		scope.ratio = powerNew / weightNew;
		scope.ratio = scope.ratio.toFixed(3);
		}), 50)
		

	});
	
		
        scope.$on('streamsUpdate', function (event, streams) {
			if (streams.engineInfo) {

				scope.math = streams.engineInfo[21] /10;
				scope.math2 = Math.floor(scope.math *10);
				scope.math3 = Math.ceil(scope.math2 * 0.986)
				scope.$digest();

				scope.curHP = scope.math3;
			};
        });

        scope.$on('$destroy', function () {
          StreamsManager.remove(['forcedInductionInfo', 'engineInfo']);
        });
      }
    };
  }]);
