angular.module('beamng.apps')
.directive('cbzTempC', ['$log', function ($log) {
	
	let style = document.createElement('style');
    style.type = 'text/css';
    style.innerHTML = `
      @font-face {
        font-family: 'Hemi';
        src: url('/ui/modules/apps/cbzhemi.ttf') format('truetype');
      }

      .cbzTempCt {
        font-family: 'Hemi';
        color: white;
      }


      .cbzTempCu {
        font-family: 'Hemi';
        color: skyblue;
      }
	  `;

    return {
      template:
	  `
      <div style="width:100%; height:100%;" layout="column" align="center" class="bngApp" id="cbzTempC">
		<p class="cbzTempCt" style="margin-top: -6%; margin-bottom: -10%">{{speed}}</p>
		<p class="cbzTempCu" style="margin-top:  4%; margin-bottom: -10%;">{{unit}}</p>
	  </div>`,
      replace: true,
      restrict: 'EA',
      link: function (scope, element, attrs) {
        StreamsManager.add(['electrics', 'engineInfo']);
		
		document.getElementsByTagName('head')[0].appendChild(style);
	
	window.setTimeout( function() {
		var doc = document.getElementById('cbzTempC');
		var doc1 = document.getElementById('cbzTempC').getElementsByClassName('cbzTempCt');
		var doc2 = document.getElementById('cbzTempC').getElementsByClassName('cbzTempCu');
		var h = doc.clientHeight;
		doc1[0].style.fontSize=h*0.69+'px';
		doc2[0].style.fontSize=h*0.29+'px';
	}, 10);
		
		
		
        scope.$on('streamsUpdate', function (event, streams) {
			if (streams.engineInfo != null && streams.electrics != null) {
				        
				var temp = streams.electrics.watertemp;
				scope.unit="Water temp";
					scope.temp = Math.floor(temp*1);
					scope.speed = (scope.temp + "°c");
				scope.$digest();

		var colchange = document.getElementById('cbzTempC').getElementsByClassName('cbzTempCt');
	                if(scope.temp < 60) { //we are cold, blue
	                    colchange[0].style.color = "lightblue"
 	               } else if(scope.temp > 104) { //we are hot, red
 	                    colchange[0].style.color = "tomato"
  	               } else { //normal amount, white
  	                    colchange[0].style.color = "white"
   	               }

			};
        });

        scope.$on('$destroy', function () {
          StreamsManager.remove(['electrics', 'engineInfo']);
        });
      }
    };
  }]);
