angular.module('beamng.apps')
.directive('cbzTempF', ['$log', function ($log) {
	
	let style = document.createElement('style');
    style.type = 'text/css';
    style.innerHTML = `
      @font-face {
        font-family: 'Hemi';
        src: url('/ui/modules/apps/cbzhemi.ttf') format('truetype');
      }

      .cbztempft {
        font-family: 'Hemi';
        color: white;
      }


      .cbztempfu {
        font-family: 'Hemi';
        color: skyblue;
      }
	  `;

    return {
      template:
	  `
      <div style="width:100%; height:100%;" layout="column" align="center" class="bngApp" id="cbzTempF">
		<p class="cbztempft" style="margin-top: -5%; margin-bottom: -10%">{{speed}}</p>
		<p class="cbztempfu" style="margin-top:  4%; margin-bottom: -10%;">{{unit}}</p>
	  </div>`,
      replace: true,
      restrict: 'EA',
      link: function (scope, element, attrs) {
        StreamsManager.add(['electrics', 'engineInfo']);
		
		document.getElementsByTagName('head')[0].appendChild(style);
	
	window.setTimeout( function() {
		var doc = document.getElementById('cbzTempF');
		var doc1 = document.getElementById('cbzTempF').getElementsByClassName('cbztempft');
		var doc2 = document.getElementById('cbzTempF').getElementsByClassName('cbztempfu');
		var h = doc.clientHeight;
		doc1[0].style.fontSize=h*0.65+'px';
		doc2[0].style.fontSize=h*0.29+'px';
	}, 10);
		
		
		
        scope.$on('streamsUpdate', function (event, streams) {
			if (streams.engineInfo != null && streams.electrics != null) {
				        
				var temp = streams.electrics.watertemp;
				scope.unit="Water temp";
					scope.temp = Math.floor((temp*1.8)+32);
					scope.speed = (scope.temp + "°f");
				scope.$digest();

		var colchange = document.getElementById('cbzTempF').getElementsByClassName('cbztempft');
	                if(scope.temp < 140) { //we are cold, blue
	                    colchange[0].style.color = "lightblue"
 	               } else if(scope.temp > 219) { //we are hot, red
 	                    colchange[0].style.color = "tomato"
  	               } else { //normal amount, white
  	                    colchange[0].style.color = "white"
   	               }

			};
        });

        scope.$on('$destroy', function () {
          StreamsManager.remove(['electrics', 'engineInfo']);
        });
      }
    };
  }]);
